export declare const log: Console;
/**
 * 获取apiPath
 */
export declare function getPath(apiMethod: any): any;
/**
 * 序列化化数据
 * @param  {Object} data 数据对象
 * @return {String}      URL用数据
 */
export declare function serialize(data: any): string;
/**
 * 查询是否为空对象
 * @param  {Object}  obj 查询对象
 * @return {Boolean}     查询结果
 */
export declare function isObjEmpty(obj: any): boolean;
/**
 * 获取标准分页数据
 * @param  {Object} data 源数据
 * @return {Object}      标准分页数据
 */
export declare function getPageData(data: any): {
    current: any;
    total: any;
    pageSize: any;
    showSizeChanger: boolean;
    showTotal(total: any): string;
    pageSizeOptions: any;
};
/**
 * 通过枚举获取数组
 * @param  {Object} enumObj 枚举对象
 * @return {Array}          数组
 */
export declare function getEnumsArray(enumObj: any): {
    text: any;
    value: string;
}[];
/**
 * 过滤空数据
 */
export declare function filterEmptyData(data: any): any;
/**
 * 去除字符串空格
 */
export declare function trim(str: any, position: any): any;
export declare function getCityTreeData(level: any): any[];
/**
 * 防抖函数(防止目标函数过于频繁的调用)
 * @param {*} func 目标函数
 * @param {*} wait 延迟时间ms
 * @param {*} immediate 是否立即执行
 */
export declare function debounce(func: any, wait: any, immediate?: boolean): {
    (event: any): void;
    cancel(): void;
};
export declare const isType: (target: any) => any;
export declare const isEqual: (obj1: any, obj2: any) => any;
