import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

/**
 * 省市区级联组件
 */
import React, { useState, useEffect } from 'react';
import { Row, Col, Cascader, Input } from 'antd';
import { getCityTreeData } from '../../../common/tool';
import { addressLength } from '../../../enums/rule'; // 封装组件

var AddressSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var addressSelectRef = React.useRef();
  addressSelectRef = ref;
  var isOpen = React.useRef(true);

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = useState(props.value.slice(0, 3) || []),
      _useState4 = _slicedToArray(_useState3, 2),
      selectValue = _useState4[0],
      setSelectValue = _useState4[1];

  var _useState5 = useState(props.value.slice(3) || []),
      _useState6 = _slicedToArray(_useState5, 2),
      inputValue = _useState6[0],
      setInputValue = _useState6[1];

  useEffect(function () {
    var level = props.level;
    var data = getCityTreeData(level);

    if (isOpen.current) {
      setOptions(data);
    }

    return function () {
      isOpen.current = false;
    };
  }, []);

  var handleSelectChange = function handleSelectChange(data) {
    var onChange = props.onChange;
    setSelectValue(data);
    onChange(data.concat(inputValue));
  };

  var handleInputChange = function handleInputChange(event) {
    var onChange = props.onChange;
    var value = event.target.value;
    var data = value ? [value] : [];
    setInputValue(data);
    onChange(selectValue.concat(data));
  };

  var disabled = props.disabled;
  var level = props.level || 3;
  var input = inputValue.join();
  var inputLength = input.length;
  return /*#__PURE__*/React.createElement("div", {
    ref: addressSelectRef
  }, level === 4 ? /*#__PURE__*/React.createElement(Row, {
    gutter: 8
  }, /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Cascader, {
    disabled: disabled,
    defaultValue: selectValue,
    options: options,
    onChange: handleSelectChange,
    placeholder: "\u8BF7\u9009\u62E9"
  })), /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Input, {
    disabled: disabled,
    defaultValue: input,
    maxLength: addressLength,
    onChange: handleInputChange,
    suffix: "".concat(inputLength, "/").concat(addressLength)
  }))) : /*#__PURE__*/React.createElement(Cascader, {
    disabled: disabled,
    defaultValue: selectValue,
    options: options,
    onChange: handleSelectChange,
    placeholder: "\u8BF7\u9009\u62E9"
  }));
});
export default AddressSelect;