/**
 * 年份选择
 */
import React from 'react';
import { Select } from 'antd';
var Option = Select.Option;
var YearSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var yearSelectRef = React.useRef();
  yearSelectRef = ref;

  var handleChange = function handleChange(value) {
    var onChange = props.onChange;
    onChange(value);
  };

  var now = new Date();
  var currentYear = now.getFullYear();
  var yearList = [];
  var yearOffset = props.offset || 10;

  if (props.after || props.before) {
    var yearBefore = props.before || 0;
    var yearAfter = props.after || 0;

    for (var i = -yearBefore; i <= yearAfter; i++) {
      yearList.push(currentYear + i);
    }
  } else {
    for (var _i = -yearOffset; _i <= yearOffset; _i++) {
      yearList.push(currentYear + _i);
    }
  }

  return /*#__PURE__*/React.createElement(Select, {
    onChange: handleChange,
    defaultValue: props.value,
    ref: yearSelectRef
  }, /*#__PURE__*/React.createElement(Option, {
    value: ""
  }, "\u8BF7\u9009\u62E9\u5E74\u4EFD"), yearList.map(function (item) {
    return /*#__PURE__*/React.createElement(Option, {
      value: item,
      key: item
    }, item);
  }));
});
export default YearSelect;