"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _api = require("../../../common/api");

var _tool = require("../../../common/tool");

/**
 * 异步选择组件
 */
var Option = _antd.Select.Option; // 封装组件

var AjaxSelect = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var isOpen = _react.default.useRef(true);

  var ajaxSelectRef = _react.default.useRef();

  ajaxSelectRef = ref;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      listData = _useState4[0],
      setListData = _useState4[1];

  (0, _react.useEffect)(function () {
    handleGetList();
    return function () {
      isOpen.current = false;
    };
  }, []);

  var handleGetList = function handleGetList() {
    var apiPath = props.apiPath,
        apiData = props.apiData,
        apiMethod = props.apiMethod,
        listName = props.listName;
    setLoading(true);
    (0, _api.fetch)(apiPath, apiData, apiMethod).then(function (data) {
      if (isOpen.current) {
        setLoading(false);
        setListData(data.data);
      }
    }).catch(function (err) {
      _tool.log.error(err);

      _antd.message.error("\u83B7\u53D6".concat(listName, "\u5931\u8D25:").concat(err.message));
    });
  };

  var handleChange = function handleChange(key) {
    var value = props.value,
        listValueKey = props.listValueKey,
        listNameKey = props.listNameKey,
        onChange = props.onChange;

    if (Array.isArray(value)) {
      if (!key) return onChange(['', '']);
      var label;
      listData.some(function (item) {
        if (item[listValueKey].toString() === key) {
          label = item[listNameKey];
          return true;
        }

        return false;
      });
      onChange([key, label]);
    } else {
      onChange(key || '');
    }
  };

  var value = props.value,
      listName = props.listName,
      listValueKey = props.listValueKey,
      listNameKey = props.listNameKey,
      disabled = props.disabled;
  var selectValue;

  if (Array.isArray(value)) {
    selectValue = value[0];
  } else {
    selectValue = value;
  }

  return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    spinning: loading,
    className: "app-ajax-select"
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    showSearch: true,
    optionFilterProp: "children",
    value: selectValue,
    onChange: handleChange,
    placeholder: "\u9009\u62E9".concat(listName),
    notFoundContent: "\u672A\u627E\u5230".concat(listName),
    allowClear: true,
    disabled: disabled,
    ref: ajaxSelectRef
  }, /*#__PURE__*/_react.default.createElement(Option, {
    value: "",
    title: "\u9009\u62E9".concat(listName)
  }, "\u9009\u62E9", listName), listData.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: index,
      value: item[listValueKey].toString(),
      title: item[listNameKey]
    }, item[listNameKey]);
  })));
});

var _default = AjaxSelect;
exports.default = _default;