"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _api = require("../../../common/api");

var _tool = require("../../../common/tool");

/**
 * 异步选择组件(多选)
 */
var Option = _antd.Select.Option;

var AjaxSelectMulit = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var isOpen = _react.default.useRef(true);

  var jaxSelectMulitRef = _react.default.useRef();

  jaxSelectMulitRef = ref;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      listData = _useState4[0],
      setListData = _useState4[1];

  (0, _react.useEffect)(function () {
    handleGetList();
    return function () {
      isOpen.current = false;
    };
  }, []);

  var handleGetList = function handleGetList() {
    var apiPath = props.apiPath,
        apiData = props.apiData,
        apiMethod = props.apiMethod,
        listName = props.listName;
    setLoading(true);
    (0, _api.fetch)(apiPath, apiData, apiMethod).then(function (data) {
      // 判断如果卸载,则不再设置数据
      if (!isOpen.current) return;
      setLoading(false);
      setListData(data.data);
    }).catch(function (err) {
      _tool.log.error(err);

      setLoading(false);

      _antd.message.error('获取' + listName + '失败');
    });
  };

  var handleChange = function handleChange(value) {
    var onChange = props.onChange,
        listValueKey = props.listValueKey,
        listNameKey = props.listNameKey;
    value.map(function (item) {
      item[listValueKey] = item.key;
      item[listNameKey] = item.label;
      delete item.key;
      delete item.label;
    });
    onChange(value);
  };

  var value = props.value;
  var listName = props.listName,
      listValueKey = props.listValueKey,
      listNameKey = props.listNameKey,
      disabled = props.disabled;
  value = value && Array.isArray(value) ? value : [];
  value = listData && listData.length ? value.map(function (item) {
    var target = listData.find(function (listItem) {
      return listItem[listValueKey] == item[listValueKey];
    });
    return target && {
      key: target[listValueKey] + '',
      label: target[listNameKey]
    };
  }).filter(function (item) {
    return item != null;
  }) : [];
  return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    spinning: loading,
    className: "app-ajax-select-multi"
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    ref: jaxSelectMulitRef,
    mode: "multiple",
    showSearch: true,
    allowClear: true,
    value: value,
    onChange: handleChange,
    placeholder: '选择' + listName,
    optionFilterProp: "children",
    labelInValue: true,
    notFoundContent: '未找到' + listName,
    disabled: disabled
  }, listData.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: index,
      value: item[listValueKey] ? item[listValueKey].toString() : '',
      title: item[listNameKey]
    }, item[listNameKey]);
  })));
});

var _default = AjaxSelectMulit;
exports.default = _default;