"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _api = require("../../../common/api");

var _tool = require("../../../common/tool");

/**
 * 通用表格
 */
var CommonTable = function CommonTable(props) {
  var isOpen = _react.default.useRef(true);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = (0, _react.useState)({
    content: []
  }),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      tableData = _useState4[0],
      setTableData = _useState4[1];

  (0, _react.useEffect)(function () {
    handleGetData({
      page: 1,
      pageSize: 10
    });
    return function () {
      isOpen.current = false;
    };
  }, []);

  var handleGetData = function handleGetData(queryData) {
    var apiPath = props.apiPath,
        apiData = props.apiData,
        apiMethod = props.apiMethod;
    setLoading(true);
    var sendData = (0, _tool.filterEmptyData)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, apiData), queryData));
    (0, _api.fetch)(apiPath, sendData, apiMethod).then(function (data) {
      // 判断如果卸载,则不再设置数据
      if (!data.data || !data.data.content) data.data.content = [];
      data.data.content.map(function (item, inx) {
        item.key = inx;
      });

      if (isOpen.current) {
        setLoading(false);
        setTableData(data.data);
      }
    }).catch(function (err) {
      setLoading(false);

      _antd.message.error("\u83B7\u53D6\u6570\u636E\u5931\u8D25:".concat(err.message));
    });
  };

  var handleChangePage = function handleChangePage(page, filters, sorter) {
    var sortType = props.sortType;
    var orders = {};

    if (!(0, _tool.isObjEmpty)(sorter)) {
      sortType.map(function (item) {
        if (item.text == sorter.columnKey) {
          orders = {
            sortType: item.value,
            isDesc: sorter.order === 'descend' ? 1 : 0
          };
        }
      });
    }

    handleGetData((0, _objectSpread2.default)({
      page: page.current,
      pageSize: page.pageSize
    }, orders));
  };

  var tableTitle = props.tableTitle,
      columns = props.columns,
      isShowPagination = props.isShowPagination,
      isShowBordered = props.isShowBordered,
      rightLink = props.rightLink,
      rightLinkTitle = props.rightLinkTitle,
      pageSizeOptions = props.pageSizeOptions,
      rowKeyFun = props.rowKeyFun,
      scroll = props.scroll;
  var pageData;

  if (isShowPagination && pageSizeOptions) {
    pageData = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, (0, _tool.getPageData)(tableData)), {}, {
      pageSizeOptions: pageSizeOptions
    });
  } else pageData = (0, _objectSpread2.default)({}, (0, _tool.getPageData)(tableData));

  return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    spinning: loading
  }, tableTitle ? /*#__PURE__*/_react.default.createElement("h3", null, tableTitle, rightLink ? /*#__PURE__*/_react.default.createElement("a", {
    className: "right-link pull-right",
    href: rightLink,
    target: "_blank",
    rel: "noopener noreferrer"
  }, rightLinkTitle) : null) : null, /*#__PURE__*/_react.default.createElement(_antd.Table, {
    columns: columns,
    bordered: isShowBordered,
    pagination: isShowPagination ? pageData : false,
    dataSource: tableData.content,
    onChange: handleChangePage,
    rowKey: rowKeyFun,
    scroll: scroll
  }));
};

CommonTable.propTypes = {
  rightLink: _propTypes.default.string,
  rightLinkTitle: _propTypes.default.string,
  tableTitle: _propTypes.default.string,
  columns: _propTypes.default.array.isRequired,
  isShowBordered: _propTypes.default.bool,
  isShowPagination: _propTypes.default.bool,
  apiPath: _propTypes.default.string.isRequired,
  apiData: _propTypes.default.object,
  apiMethod: _propTypes.default.string,
  sortType: _propTypes.default.array,
  pageSizeOptions: _propTypes.default.array,
  rowKeyFun: _propTypes.default.func,
  scroll: _propTypes.default.object
};
CommonTable.defaultProps = {
  isShowBordered: true
};
var _default = CommonTable;
exports.default = _default;