"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _pdf_view = _interopRequireDefault(require("./pdf_view"));

var _zoom_image = _interopRequireDefault(require("./zoom_image"));

var _dragble_modal = _interopRequireDefault(require("./dragble_modal"));

require("../../../style/super_file_preview.less");

/**
 * 文件预览组件(可以拖动)
 */
var SuperFilePreview = function SuperFilePreview(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      modal = _useState2[0],
      setModal = _useState2[1];

  var handleCloseModal = function handleCloseModal() {
    setModal(false);
  };

  var renderImage = function renderImage() {
    var isZoom = props.isZoom,
        children = props.children,
        path = props.path;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "app-file-preview"
    }, /*#__PURE__*/_react.default.createElement("div", {
      onClick: function onClick(e) {
        e.preventDefault();
        setModal(true);
      }
    }, children), modal ? isZoom ? /*#__PURE__*/_react.default.createElement(_zoom_image.default, {
      path: path,
      onCancel: handleCloseModal
    }) : /*#__PURE__*/_react.default.createElement(_dragble_modal.default, {
      title: "\u56FE\u7247\u9884\u89C8",
      onCancel: handleCloseModal
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "app-file-preview-image"
    }, /*#__PURE__*/_react.default.createElement("a", {
      href: path,
      target: "_blank",
      rel: "noopener noreferrer"
    }, /*#__PURE__*/_react.default.createElement("img", {
      src: path
    })))) : null);
  };

  var path = props.path,
      children = props.children,
      pdfHeight = props.pdfHeight;
  var match = path && path.match(/\.(pdf|jpg|jpeg|png|gif)/i);
  var suffix = match ? match[1] : '';

  switch (suffix) {
    case 'pdf':
      return /*#__PURE__*/_react.default.createElement(_pdf_view.default, {
        path: path,
        pdfHeight: pdfHeight
      }, children);

    case 'jpg':
    case 'jpeg':
    case 'png':
    case 'gift':
      return renderImage();

    default:
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "app-file-preview"
      }, children);
  }
};

var _default = SuperFilePreview;
exports.default = _default;