"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _tool = require("../../../common/tool");

var _rule = require("../../../enums/rule");

/**
 * 省市区级联组件
 */
// 封装组件
var AddressSelect = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var addressSelectRef = _react.default.useRef();

  addressSelectRef = ref;

  var isOpen = _react.default.useRef(true);

  var _useState = (0, _react.useState)([]),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = (0, _react.useState)(props.value.slice(0, 3) || []),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      selectValue = _useState4[0],
      setSelectValue = _useState4[1];

  var _useState5 = (0, _react.useState)(props.value.slice(3) || []),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      inputValue = _useState6[0],
      setInputValue = _useState6[1];

  (0, _react.useEffect)(function () {
    var level = props.level;
    var data = (0, _tool.getCityTreeData)(level);

    if (isOpen.current) {
      setOptions(data);
    }

    return function () {
      isOpen.current = false;
    };
  }, []);

  var handleSelectChange = function handleSelectChange(data) {
    var onChange = props.onChange;
    setSelectValue(data);
    onChange(data.concat(inputValue));
  };

  var handleInputChange = function handleInputChange(event) {
    var onChange = props.onChange;
    var value = event.target.value;
    var data = value ? [value] : [];
    setInputValue(data);
    onChange(selectValue.concat(data));
  };

  var disabled = props.disabled;
  var level = props.level || 3;
  var input = inputValue.join();
  var inputLength = input.length;
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: addressSelectRef
  }, level === 4 ? /*#__PURE__*/_react.default.createElement(_antd.Row, {
    gutter: 8
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Cascader, {
    disabled: disabled,
    defaultValue: selectValue,
    options: options,
    onChange: handleSelectChange,
    placeholder: "\u8BF7\u9009\u62E9"
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    disabled: disabled,
    defaultValue: input,
    maxLength: _rule.addressLength,
    onChange: handleInputChange,
    suffix: "".concat(inputLength, "/").concat(_rule.addressLength)
  }))) : /*#__PURE__*/_react.default.createElement(_antd.Cascader, {
    disabled: disabled,
    defaultValue: selectValue,
    options: options,
    onChange: handleSelectChange,
    placeholder: "\u8BF7\u9009\u62E9"
  }));
});

var _default = AddressSelect;
exports.default = _default;