"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _country_data = require("../../../enums/country_data");

/**
 * 国家地区组件
 */
var Option = _antd.Select.Option;

// 封装组件
var CountrySelect = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var countrySelectRef = _react.default.useRef();

  countrySelectRef = ref;

  var handleChange = function handleChange(value) {
    var onChange = props.onChange;
    onChange(value);
  };

  var value = props.value,
      disabled = props.disabled;
  return /*#__PURE__*/_react.default.createElement(_antd.Select, {
    onChange: handleChange,
    defaultValue: value,
    disabled: disabled,
    ref: countrySelectRef
  }, /*#__PURE__*/_react.default.createElement(Option, {
    value: ""
  }, "\u8BF7\u9009\u62E9\u56FD\u5BB6/\u5730\u533A"), _country_data.countryList.map(function (item) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: item.regionId,
      key: item.regionId
    }, item.regionName);
  }));
});

var _default = CountrySelect;
exports.default = _default;