"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _const = require("../../../enums/const");

var _moment = _interopRequireDefault(require("moment"));

var Option = _antd.Select.Option;

var QuarterPicker = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var quarterPickerRef = _react.default.useRef();

  quarterPickerRef = ref;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var handleOpenChange = function handleOpenChange(value) {
    setOpen(value);
  };

  var handleDateChange = function handleDateChange(value) {
    var onChange = props.onChange;
    onChange(value);
  };

  var handlePanelChange = function handlePanelChange(value) {
    var onChange = props.onChange;
    setOpen(false);
    onChange(value);
  };

  var handleSelectChange = function handleSelectChange(quarter) {
    var onChange = props.onChange,
        value = props.value;
    var quarterValue = (value || (0, _moment.default)()).quarter(parseInt(quarter));
    onChange(quarterValue);
  };

  var value = props.value,
      disabled = props.disabled;
  var quarterValue = value ? value.quarter() + '' : '';
  return /*#__PURE__*/_react.default.createElement(_antd.Row, {
    ref: quarterPickerRef,
    gutter: 8
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.DatePicker, {
    mode: "year",
    value: value,
    open: open,
    disabled: disabled,
    style: {
      width: '100%'
    },
    onOpenChange: handleOpenChange,
    onChange: handleDateChange,
    onPanelChange: handlePanelChange,
    placeholder: "\u9009\u62E9\u5E74\u4EFD",
    format: _const.dateFormatOnlyYearCh
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    placeholder: "\u9009\u62E9\u5B63\u5EA6",
    value: quarterValue,
    onChange: handleSelectChange,
    disabled: disabled,
    style: {
      width: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement(Option, {
    value: "1"
  }, "\u7B2C\u4E00\u5B63\u5EA6"), /*#__PURE__*/_react.default.createElement(Option, {
    value: "2"
  }, "\u7B2C\u4E8C\u5B63\u5EA6"), /*#__PURE__*/_react.default.createElement(Option, {
    value: "3"
  }, "\u7B2C\u4E09\u5B63\u5EA6"), /*#__PURE__*/_react.default.createElement(Option, {
    value: "4"
  }, "\u7B2C\u56DB\u5B63\u5EA6"))));
});

var _default = QuarterPicker;
exports.default = _default;